/*
 * COPYRIGHT (c) International Business Machines Corp. 2024
 *
 * This program is provided under the terms of the Common Public License,
 * version 1.0 (CPL-1.0). Any use, reproduction or distribution for this
 * software constitutes recipient's acceptance of CPL-1.0 terms which can be
 * found in the file LICENSE file or at
 * https://opensource.org/licenses/cpl1.0.php
 */
/* AUTO-GENERATED on Mon Dec  2 05:49:14 2024.  DO NOT EDIT! */

#include <string.h>
#include <pkcs11types.h>
#include "mechtable.h"
#include "mechtable.inc"

static const unsigned char numericalphabet[] = {
  0, 1, 2, 3, 4, 5, 6, 7,
  0, 8, 9, 10, 11, 12, 13, 0,
  14, 15, 16, 0, 0, 0, 0, 0,
  0, 0, 0, 17, 18, 0, 19, 20,
  21, 22, 23, 24, 25, 26, 27, 28,
  29, 0, 0, 0, 0, 0, 0, 0,
  30, 31, 32, 33, 34, 35, 36, 37,
  38, 0, 0, 0, 0, 0, 0, 0,
  39, 40, 41, 42, 43, 44, 45, 46,
  47, 48, 49, 0, 50, 51, 52, 0,
  53, 54, 55, 56, 0, 57, 58, 59,
  0, 0, 0, 0, 0, 0, 0, 0,
  60, 61, 62, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  63, 64, 65, 0, 66, 0, 67, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  68, 69, 70, 71, 72, 73, 74, 75,
  0, 76, 77, 0, 0, 0, 0, 0,
  0, 0, 78, 79, 80, 81, 82, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  83, 0, 0, 0, 0, 0, 0, 0,
  84, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
};
static const short numerictable[] = {
  -73, -72, 151, -76, 3, -70, -83, -49,
  -74, -78, -77, -85, -75, -84, -37, -36,
  -39, 30, 4, -38, -35, -34, -33, 24,
  28, -67, -68, -69, 2, -50, 111, 0,
  -79, -80, -81, 0, 0, 0, 0, -96,
  -102, -114, -97, -103, -115, -90, -91, -105,
  -106, -107, -108, -109, -110, -47, -41, -42,
  -43, -44, -45, -46, 0, 0, 0, 0,
  -92, -93, -94, -40, -86, -87, -88, -98,
  -99, -100, -104, -111, -112, 0, -13, -12,
  0, 0, -11, -9, -1, -14, -15, -2,
  -8, -10, -7, -6, -31, -30, -26, 0,
  16, -27, 0, 0, 0, -17, -23, -22,
  -18, -24, -25, -19, -21, -20, 0, 0,
  -59, -61, -63, -65, 0, 0, -51, -16,
  -4, -5, -3, -123, -32, 0, -28, -29,
  -54, -56, -55, -57, 0, -48, 0, -52,
  -58, -60, -62, -64, -66, 0, -53, -119,
  -117, -116, -122, -121, -118, -120, 0, 0,
  71, 11, 80, 0, 0, 0, -82, -95,
  -101, -113, -89, -71, -124, 14, 0, 0,
  0, 0, 0, 0, 19, 115, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0,
};
int mechtable_idx_from_numeric(CK_ULONG mech)
{
    unsigned int idx1, idx2, idx3, idx4;
    int o1, o2, o3;
    int midx;

    idx1 = numericalphabet[(mech & 0xff000000u) >> 24u];
    idx2 = numericalphabet[(mech & 0x00ff0000u) >> 16u];
    idx3 = numericalphabet[(mech & 0x0000ff00u) >> 8u];
    idx4 = numericalphabet[mech & 0x000000ffu];
    o1 = numerictable[28 + idx1];
    if (o1 < 0) return -1;
    o2 = numerictable[o1 + idx2];
    if (o2 < 0) return -1;
    o3 = numerictable[o2 + idx3];
    if (o3 < 0) return -1;
    midx = numerictable[o3 + idx4];
    midx = -(midx + 1);
    if (0 <= midx && midx < 124 && mechtable_rows[midx].numeric == mech)
        return midx;
    return -1;
}

const struct mechrow *mechrow_from_numeric(CK_ULONG mech)
{
    int idx = mechtable_idx_from_numeric(mech);

    if (idx < 0)
        return NULL;
    return &mechtable_rows[idx];
}

static const unsigned char stringalphabet[] = {
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  1, 2, 3, 4, 5, 6, 7, 0,
  8, 9, 0, 0, 0, 0, 0, 0,
  0, 10, 11, 12, 13, 14, 15, 16,
  17, 18, 0, 19, 20, 21, 22, 23,
  24, 0, 25, 26, 27, 28, 29, 30,
  31, 32, 0, 0, 0, 0, 0, 33,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
};
static const short stringtable[] = {
  0, 0, 201, 89, 267, -36, 289, 167,
  28, 197, 9, 206, 136, 3, 167, 151,
  -48, 120, 176, 155, 137, 198, 141, 10,
  326, 191, 40, 306, 37, 168, -9, 196,
  -10, 226, 196, 317, 49, 131, 81, -16,
  -49, -50, -51, -52, 56, 93, 192, 110,
  118, -58, -17, 114, 121, 1, -70, -22,
  175, 217, 123, 287, -23, -113, 148, 4,
  -8, -30, 301, 286, 95, 194, -31, -42,
  182, -45, -32, -46, 226, 241, -89, -95,
  51, 256, 16, -101, 226, 241, -116, 201,
  315, 256, 89, -119, 241, -120, 105, 254,
  289, -3, -33, 294, -37, -41, -4, -5,
  -34, -38, -40, -39, -53, -35, -47, -67,
  -72, -73, 190, 170, -79, -74, -75, -82,
  222, -86, -92, -98, -104, 210, -105, -85,
  160, -108, 131, -1, 95, 123, 155, 136,
  -6, 113, -76, 140, -13, 130, 143, -14,
  29, 94, 47, 41, 150, 212, -18, 140,
  153, -20, 59, 60, 64, 42, 148, 278,
  161, -24, 285, 165, -2, -26, 160, -28,
  -29, -7, 147, 153, 162, -12, 149, 144,
  -15, 85, 5, 77, 101, 165, 174, -19,
  69, -43, -21, 168, -44, 157, 30, 190,
  186, -54, -25, -55, 3, -56, -27, -57,
  5, 202, -59, 204, -61, 201, 207, -63,
  206, 210, -65, 206, 111, 204, 203, 216,
  -68, 208, 186, 63, 209, 196, 112, 220,
  223, 226, -77, 0, 116, 209, 221, 220,
  233, -80, 100, -60, 228, -62, 206, 96,
  -64, 230, 218, -66, 245, -83, 121, 238,
  238, -69, 251, -87, 243, 221, 231, 237,
  245, 232, 260, -78, -90, 122, 253, 252,
  265, -93, -81, 258, 236, 246, 252, 260,
  247, 274, -96, 271, 123, 269, -84, 268,
  281, -99, 273, 252, -88, 262, 268, 276,
  263, 290, -102, 289, 124, -91, 126, 275,
  287, 287, -94, 300, -106, 129, 282, 294,
  293, 306, -109, -97, 299, 298, 311, -111,
  303, 282, -100, 292, 298, 306, 293, 320,
  -114, 318, 291, -103, 67, -117, 301, 296,
  -118, 311, -121, 300, 301, -107, 320, -122,
  -11, -71, 0, -110, 0, 0, 0, 0,
  -112, -124, 0, 0, 0, 0, -123, 0,
  0, -115, 0, 0, 0, 0, 0, 0,
};
static const size_t commonprefixlength = 4;

int mechtable_idx_from_string(const char *mech)
{
    static const struct {
        const char *string;
        const char *alias;
    } aliaslist[] = {
        { "CKM_ECDSA_KEY_PAIR_GEN", "CKM_EC_KEY_PAIR_GEN" },
        { "CKM_IBM_EC_C25519", "CKM_IBM_EC_X25519" },
        { "CKM_IBM_EC_C448", "CKM_IBM_EC_X448" },
        { "CKM_IBM_EDDSA_SHA512", "CKM_IBM_ED25519_SHA512" },
    };
    size_t len = strlen(mech), i;
    short idx = 0;
    unsigned char h;

    for (i = commonprefixlength; i <= len; ++i) {
        h = stringalphabet[(int)mech[i]];
        idx = stringtable[idx + h];
        if (idx < 0) {
            idx = -(idx + 1);
            if (strcmp(mech, mechtable_rows[idx].string) == 0)
                return idx;
            goto outcheckaliases;
        }
    }
  outcheckaliases:
    for (i = 0; i < sizeof(aliaslist) / sizeof(aliaslist[0]); ++i) {
        if (strcmp(aliaslist[i].string, mech) == 0)
            return mechtable_idx_from_string(aliaslist[i].alias);
    }
    return -1;
}

const struct mechrow *mechrow_from_string(const char *mech)
{
    int idx = mechtable_idx_from_string(mech);

    if (idx < 0)
        return NULL;
    return &mechtable_rows[idx];
}

const struct mechtable_funcs mechtable_funcs = {
    .p_idx_from_num = &mechtable_idx_from_numeric,
    .p_idx_from_str = &mechtable_idx_from_string,
    .p_row_from_num = &mechrow_from_numeric,
    .p_row_from_str = &mechrow_from_string
};

